#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2two20004xi.py">
#<abstract4xi abstract = "fires to direction two and to distance 2000"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2two20004xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2TWO - COORDINATE SIGNS OF SHOOT2TWO4XI: (X + ,Y - ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2two20004xi

#"
#/>

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

# -------------------------------------------------------------------------------------------------
# 2000
# -------------------------------------------------------------------------------------------------
shot2two20004xi = {
        1:'1030x-1714y-18z',
        2:'1051x-1680y-261z',
        3:'1118x-1657y-38z',
        4:'1136x-1621y-281z',
        5:'1203x-1596y-58z',
        6:'1218x-1557y-300z',
        7:'121x-824y-1818z',
        8:'1284x-1530y-78z',
        9:'1295x-1489y-320z',
        10:'133x-1039y-1703z',
        11:'1362x-1460y-98z',
        12:'1369x-1416y-340z',
        13:'1436x-1386y-118z',
        14:'1439x-1340y-360z',
        15:'143x-1292y-1519z',
        16:'1504x-1261y-379z',
        17:'1505x-1308y-138z',
        18:'1565x-1178y-399z',
        19:'1571x-1227y-158z',
        20:'160x-799y-1826z',
        21:'1621x-1092y-418z',
        22:'1631x-1142y-178z',
        23:'1673x-1004y-438z',
        24:'1687x-1054y-198z',
        25:'1719x-913y-457z',
        26:'1738x-963y-218z',
        27:'175x-1990y-82z',
        28:'1760x-819y-477z',
        29:'1784x-870y-238z',
        30:'1796x-724y-496z',
        31:'1825x-774y-258z',
        32:'1827x-628y-516z',
        33:'184x-1013y-1713z',
        34:'1852x-530y-535z',
        35:'1861x-677y-277z',
        36:'1872x-431y-554z',
        37:'1886x-331y-573z',
        38:'1891x-578y-297z',
        39:'1895x-231y-593z',
        40:'1897x-32y-631z',
        41:'1899x-131y-612z',
        42:'1915x-477y-317z',
        43:'1931x-517y-5z',
        44:'1935x-376y-337z',
        45:'1948x-273y-356z',
        46:'1956x-171y-376z',
        47:'1956x-415y-25z',
        48:'1959x-68y-396z',
        49:'1974x-312y-45z',
        50:'197x-771y-1834z',
        51:'1987x-208y-65z',
        52:'1995x-104y-85z',
        53:'208x-1268y-1532z',
        54:'233x-986y-1724z',
        55:'244x-779y-1934z',
        56:'25x-1081y-1682z',
        57:'271x-1240y-1545z',
        58:'279x-1977y-102z',
        59:'280x-955y-1734z',
        60:'324x-923y-1744z',
        61:'331x-1209y-1557z',
        62:'365x-889y-1753z',
        63:'36x-868y-1801z',
        64:'381x-1959y-122z',
        65:'389x-1175y-1570z',
        66:'403x-852y-1763z',
        67:'439x-815y-1772z',
        68:'444x-1139y-1582z',
        69:'472x-775y-1781z',
        70:'483x-1935y-141z',
        71:'497x-1099y-1594z',
        72:'502x-735y-1790z',
        73:'529x-693y-1799z',
        74:'546x-1058y-1606z',
        75:'553x-651y-1808z',
        76:'555x-16y-1921z',
        77:'572x-46y-1915z',
        78:'573x-608y-1816z',
        79:'583x-1906y-161z',
        80:'588x-79y-1909z',
        81:'591x-564y-1825z',
        82:'593x-1014y-1618z',
        83:'602x-113y-1903z',
        84:'606x-521y-1833z',
        85:'613x-149y-1897z',
        86:'618x-477y-1841z',
        87:'623x-186y-1891z',
        88:'627x-433y-1848z',
        89:'630x-225y-1884z',
        90:'633x-390y-1856z',
        91:'635x-265y-1877z',
        92:'636x-348y-1863z',
        93:'636x-968y-1630z',
        94:'637x-306y-1870z',
        95:'676x-920y-1641z',
        96:'682x-1871y-181z',
        97:'70x-1997y-62z',
        98:'713x-870y-1652z',
        99:'747x-820y-1664z',
        100:'76x-1313y-1506z',
        101:'777x-768y-1675z',
        102:'778x-1831y-201z',
        103:'79x-847y-1809z',
        104:'7x-1330y-1493z',
        105:'803x-715y-1685z',
        106:'80x-1061y-1693z',
        107:'826x-661y-1696z',
        108:'846x-607y-1707z',
        109:'847x-39y-1811z',
        110:'862x-553y-1717z',
        111:'862x-85y-1802z',
        112:'872x-1786y-221z',
        113:'874x-133y-1793z',
        114:'875x-498y-1727z',
        115:'883x-182y-1784z',
        116:'884x-444y-1737z',
        117:'890x-232y-1775z',
        118:'891x-390y-1747z',
        119:'893x-284y-1766z',
        120:'893x-337y-1757z',
        121:'963x-1735y-241z'}         
        
        
#"
#"/>

        
# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire2000two4xi" usage = "target function for chargeone4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire2000two4xi(queue2two, consumer_channel2two, publisher_channel2two):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2000TWO4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE2000TWO4XI -  QUEUE2TWO: ", queue2two)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2000TWO4XI -  CONSUMER_CHANNEL2TWO: ", consumer_channel2two)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE2000TWO4XI -  PUBLISHER_CHANNEL2TWO: ", publisher_channel2two)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2000TWO4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2TWO: ", queue2two, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2two.put(shot2two20004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2000TWO4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2TWO: ", queue2two, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2000TWO4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2TWO: ", queue2two, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2000TWO4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2TWO: ", publisher_channel2two, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2two8shot2two20004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2two8shot2two20004xi</nack2put4xi>" 
            
        publisher_channel2two.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2000TWO4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2TWO: ", publisher_channel2two, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE2000TWO4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2TWO: ", publisher_channel2two, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2000TWO4XI - RETURNING QUEUE OBJECT QUEUE2TWO: ", queue2two, " - TIME: ", time4xi())  
        # 
            
    return queue2two    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verbkb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2two20004xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
        